// Copyright 2023-2024 DreamWorks Animation LLC and Intel Corporation
// SPDX-License-Identifier: Apache-2.0

#ifndef __ARRAS4_EVENT_HANDLER_H__
#define __ARRAS4_EVENT_HANDLER_H__

#include <message_api/UUID.h>
#include <message_api/Object.h>

namespace arras4 {
    namespace node {

// handles events generated by Arras (e.g. computation ready
// or terminated) that need to be forward to an external observer
// (e.g. coordinator)
class EventHandler
{
public:
    virtual ~EventHandler() {}
    // compId can be null for session-level events
    virtual void handleEvent(const api::UUID& sessionId,
			     const api::UUID& compId,
			     api::ObjectConstRef eventData)=0;
};

    }
}
#endif
